function Wave_Function_2D(a,FrameNumber,k,amp,filename,cview, viewaxis,viewaxislabel,zoom)
% Wave_Function_2D(a,FrameNumber,k,amp,filename,cview, viewaxis,viewaxislabel,zoom)
%   Solves the 2D wave equation and generates an avi video in 2D or 3D
%   using finite differences and recursion
% Input:
%   a = width of the pool
%   Framenumber = Number of iterations
%   k = dt
%   amp = droplet height
%   filename = string: file name + location
%   cview = Camera View Angle, '2D' and '3D' are presets
%   viewaxis = 'off' or 'on' controls whether axes are visible
%   viewaxislabel = 'off' or 'on' turns x,y,z labels on or off
% output:
%   A video of a drop creating transverse waves in a rectangular pool of
%   side lengths 2 and 2a
%
% Version 1.0
%   Date Created: 02/05/2019
%   Author: Daniel Cosgrave
%   Creates a video called wave.avi of a 2D rectangular pool with a
%   propagating wave generated by a droplet with a colorbar amplitude
%   indicator
% Version 1.1
%   Date Created: 02/05/2019
%   Added filename as an input instead of a default value
%   Added droplet amplitude control
% Version 1.2
%   Date Created: 03/05/2019
%   Video is now produced in 3D
%   Added Lighting
%   Removed Colorbar as lighting is now clearly showing amplitude
%   Added camera control  and zoom as input arguments
%   Added wave velocity instead of it being normalised
% Version 1.3
%   Date Created: 03/05/2019
%   Added boundary conditions

    if nargin < 9, error("not enough input arguments"); end
    
    %viewaxislabel must be explicitly turned on if viewaxis is off
    if strcmp(viewaxis,'off') && ~strcmp(viewaxislabel,'on')
        viewaxislabel = 'off';
    end
    
    if strcmp(cview,'2D') == 1, cview = 2;
        elseif strcmp(cview,'3D') == 1, cview = [-45 90 45]; 
    end 
   
        
    %Inital velocity
    tau = 0.7197; %Surface Tension of water dyn/cm
    rho = 1; %Density of Water g/cm^3
    v=(tau/rho); %Wave Propagation Velocity;
    
    h=0.5; %dx;
    b=2*a;
    
    %Amount of Points per Axis
    x=0:h:a;
    y=0:h:b;
    W=length(x);
    L=length(y);
    
    %Set up initial conditions
    u=zeros(L,W); %Create Calm Pool

    rad=1;
    bump = -amp*bump_equation(rad); %Generate a droplet
    u(2*a:2*a+1,b/2-rad:b/2+rad)= bump; %Place the droplet in the grid
    uo=u; 

    zax = max(bump);
    close all;
    figure;
    ax=axes;
    fig=surf(x,y,u);
    xlabel('Width'), ylabel('Length'), zlabel('Height') 
    set(fig,'Linestyle','none','FaceColor',[0 1 1]);
    axis equal;
    lighting phong;
    light(ax);
    grid off

    D=[0 1 0; 1 -4 1; 0 1 0]; % 2D Laplacian operator
    r=(1/v)^2*k^2/h^2; % Velocity-Time-Space constant

    VideoObject= VideoWriter(filename);
    open(VideoObject);
    for t=0:k:FrameNumber
        
        un=2*u-1*uo+r*conv2(u,D,'same'); %Current + old points become new points
        uo = u;                          %Current points become old points
        u = un;                          %New points become current points
        
        %Boundary Conditions
        u(1,:,:) = 0;
        u(:,1,:) = 0;
        u(L,:,:) = 0;
        u(:,W,:) = 0;
        
        set(fig,'ZData',u); %u is the propagation of the wave in z at t
        drawnow; %Animate...
       
        cva= get(gca,'CameraViewAngle');     % get current camera angle
        view(cview)
        if t==0, set(gca,'CameraViewAngle',cva/zoom/1.5); end %Zoom once
        set(gca,'zlim',[zax(2) -zax(2)]); %Camera is locked to the z axis
        set(gca, 'visible', viewaxis) %View axis or grid, by default this is off
        set(findall(gca, 'type', 'text'), 'visible', viewaxislabel) %View labels, by default this is on
        current_frame=getframe(gcf);
        writeVideo(VideoObject,current_frame);
    end
  close(VideoObject);
end